<?php

/**
 * 2015 Leeenux Software
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the GPL License
 *
 *  @author <leeenux.linux@gmail.com>
 *  @copyright  Leeenux Software
 *  @license    http://opensource.org/licenses/gpl.php
 **/

if (!defined('_PS_VERSION_'))
	exit;

class Merchant extends Module {

	public function getContent()
	{
	$output = null;

	if (Tools::isSubmit('submit'.$this->name))
	{
		//SERVER_NAME
		$server_name = (string)Tools::getValue('SERVER_NAME');
		if (!$server_name || empty($server_name) || !Validate::isGenericName($server_name))
		$output .= $this->displayError($this->l('Invalid Configuration value'));
		else
		{
		Configuration::updateValue('SERVER_NAME', $server_name);
		$output .= $this->displayConfirmation($this->l('Settings updated'));
		}
		//DB_USERNAME
		$db_username = (string)Tools::getValue('DB_USERNAME');
		if (!$db_username || empty($db_username) || !Validate::isGenericName($db_username))
		$output .= $this->displayError($this->l('Invalid Configuration value'));
		else
		Configuration::updateValue('DB_USERNAME', $db_username);
		//DB_PASSWORD
		$db_password = (string)Tools::getValue('DB_PASSWORD');
		Configuration::updateValue('DB_PASSWORD', $db_password);

		//DB_NAME
		$db_name = (string)Tools::getValue('DB_NAME');
		if (!$db_name || empty($db_name) || !Validate::isGenericName($db_name))
		$output .= $this->displayError($this->l('Invalid Configuration value'));
		else
		Configuration::updateValue('DB_NAME', $db_name);
		//MERCHANTS_USERNAME
		$merchants_username = (string)Tools::getValue('MERCHANTS_USERNAME');
		if (!$merchants_username || empty($merchants_username) || !Validate::isGenericName($merchants_username))
		$output .= $this->displayError($this->l('Invalid Configuration value'));
		else
		Configuration::updateValue('MERCHANTS_USERNAME', $merchants_username);
		//MERCHANTS_PASSWORD
		$merchants_password = (string)Tools::getValue('MERCHANTS_PASSWORD');
		Configuration::updateValue('MERCHANTS_PASSWORD', $merchants_password);
		//Write into file
		$myfile = fopen('merchant.conf', 'w');
		$txt = $server_name."\r\n".$db_username."\r\n".$db_password."\r\n".$db_name."\r\n".$merchants_username."\r\n".$merchants_password;
		fwrite($myfile, $txt);
		fclose($myfile);
	}
	return $output.$this->displayForm();
	}

	public function __construct()
	{
	$this->name = 'merchant';
	$this->tab = 'others';
	$this->version = '1.1.1';
	$this->author = 'Leeenux software';
	$this->need_instance = 0;
	$this->ps_versions_compliancy = array('min' => '1.5', 'max' => '1.7');
	$this->dependencies = array('blockcart');
	$this->module_key = '4448c6d923165fa66249e13b1f524a12';

	parent::__construct();

	$this->displayName = $this->l('Merchant Module');
	$this->description = $this->l('For adding products outside of prestashop.');

	$this->confirmUninstall = $this->l('Are you sure you want to uninstall?');

	if (!Configuration::get('SERVER_NAME'))
		$this->warning = $this->l('No server name provided');
	if (!Configuration::get('DB_USERNAME'))
		$this->warning = $this->l('No db username provided');
	if (!Configuration::get('DB_PASSWORD'))
		$this->warning = $this->l('No db password provided');
	if (!Configuration::get('DB_NAME'))
		$this->warning = $this->l('No db name provided');
	}

	public function displayForm()
	{
	// Get default Language
	$default_lang = (int)Configuration::get('PS_LANG_DEFAULT');

	// Init Fields form array
	$fields_form[0]['form'] = array(
		'legend' => array(
		'title' => $this->l('Settings'),
		),
		'input' => array(
		array(
			'type' => 'text',
			'label' => $this->l('Server Name'),
			'name' => 'SERVER_NAME',
			'size' => 40,
			'required' => true
		),
		array(
			'type' => 'text',
			'label' => $this->l('DB Username'),
			'name' => 'DB_USERNAME',
			'size' => 40,
			'required' => true
		),
		array(
			'type' => 'text',
			'label' => $this->l('DB Password'),
			'name' => 'DB_PASSWORD',
			'size' => 40,
			'required' => false
		),
		array(
			'type' => 'text',
			'label' => $this->l('DB Name'),
			'name' => 'DB_NAME',
			'size' => 40,
			'required' => true
		),
		array(
			'type' => 'text',
			'label' => $this->l('Merchant\'s Username'),
			'name' => 'MERCHANTS_USERNAME',
			'size' => 40,
			'required' => true
		),
		array(
			'type' => 'text',
			'label' => $this->l('Merchant\'s Password'),
			'name' => 'MERCHANTS_PASSWORD',
			'size' => 40,
			'required' => true
		)
		),
		'submit' => array(
		'title' => $this->l('Save'),
		'class' => 'button'
		)
	);

	$helper = new HelperForm();

	// Module, t    oken and currentIndex
	$helper->module = $this;
	$helper->name_controller = $this->name;
	$helper->token = Tools::getAdminTokenLite('AdminModules');
	$helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;

	// Language
	$helper->default_form_language = $default_lang;
	$helper->allow_employee_form_lang = $default_lang;

	// Title and toolbar
	$helper->title = $this->displayName;
	$helper->show_toolbar = true; // false -> remove toolbar
	$helper->toolbar_scroll = true;      // yes - > Toolbar is always visible on the top of the screen.
	$helper->submit_action = 'submit'.$this->name;
	$helper->toolbar_btn = array(
		'save' =>
		array(
		'desc' => $this->l('Save'),
		'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name .
		'&token='.Tools::getAdminTokenLite('AdminModules'),
		),
		'back' => array(
		'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
		'desc' => $this->l('Back to list')
		)
	);

	// Load current value
	$helper->fields_value['SERVER_NAME'] = Configuration::get('SERVER_NAME');
	$helper->fields_value['DB_USERNAME'] = Configuration::get('DB_USERNAME');
	$helper->fields_value['DB_PASSWPRD'] = Configuration::get('DB_PASSWORD');
	$helper->fields_value['DB_NAME'] = Configuration::get('DB_NAME');
	$helper->fields_value['MERCHANTS_USERNAME'] = Configuration::get('MERCHANTS_USERNAME');
	$helper->fields_value['MERCHANTS_PASSWORD'] = Configuration::get('MERCHANTS_PASSWORD');
	return $helper->generateForm($fields_form);
	}

}

?>